#! /bin/bash

# reorder nproc ordered pdb and diagnostic files by replica  

# syntax: order.sh <pdb-file-name>


pdb_to_order=$1
tmp_files="ORD-*-* tmp.rep rem.*"
rm $tmp_files

# split pdb into single frames, in the same dir
for i in PAR*/${pdb_to_order}; do csplit -f "$i." $i  '/REPLICA/' '{*}' >& /dev/null; done

# copy into master dir with a meaningful name ORD-xxxx-yyyyyyyyyy;
# x=replica; y=step
for i in PAR*/${pdb_to_order}.*; do 
    [ -f $i ] && awk '/REPLICA/ {rep=sprintf("%.4d",$2);step=sprintf("%.10d",$14);print rep >> "tmp.rep"; new = "ORD-" rep "-" step; system("mv " FILENAME " " new); exit}' $i; 
done

# group diagnostic data one file per replica
awk '! /#/ {print $0 >> "rem." sprintf("%.4d",$2)}' PAR*/REM_DIAGNOSTIC 

# reorder into one file per replica
#   move '.pdb' trail in $pdb_to_order to the end of the new files
for r in `sort -u -n tmp.rep`; do 
    cat ORD-${r}-* > ${pdb_to_order%%.pdb}-${r}.pdb; 
    echo "#   time(fs) rem index         Etot         Ekin         Epot        Ekinh        Epoth" > REM-${r}
    sort -nk1 rem.${r} >> REM-${r}
done

rm $tmp_files

