#!/bin/bash
# ORAC program: Do all SMD tests sequentially 
# script has been tested on Linux platforms only. 
if [ "$1" == "" ];
then echo " TARGET program not specified; using Default"  ;
   echo "Syntax: run_parallel_tests.bash TARGET procs"
   echo "where TARGET is the full name of the program and procs is the n. of replicas"
   exit
else TARGET=$1; 
fi
if [ "$2" == "" ];  
then  
  echo  "Syntax: run_basic_test.bash TARGET procs"
  echo  "missing number of replicas (procs) " 
  exit
else NPROCS=$2
fi
    
if `test -e $TARGET`; then 
#  check for mpi
   if `test -e /usr/local/bin/mpirun` || `test -e /usr/bin/mpirun`; then 
      if `test -e mpd.hosts` ; then 
         if `test -e OUT_TEST` ; then rm OUT_TEST; fi  
         killall -9 orac_REM >&/dev/null
         killall -9 orac_I_REM >&/dev/null
         rm -fr PAR000*  >& /dev/null
#        kill mpd demon 
         mpdallexit 
#        start the mpd demon on hosts 
         echo "starting the mpd demon" 
         mpdboot -n  `wc mpd.hosts | awk '{print $1}'`
         echo "Starting the program on `cat mpd.hosts`"
         mpiexec  -n 1 $TARGET < 1a.in >& tmp ;
         echo "Doing first test for SMD ....." 
#        First test 
#        Test on driven stretching, bending and torsion of decaalanine
         echo "Testing 1a.in..." > OUT_TEST
         grep "Total    = " PAR0001/tmp >> OUT_TEST; rm PAR0001/tmp; tail -2 PAR0001/WRK.ala10 >> OUT_TEST
         echo "Testing 1b.in..." >> OUT_TEST
         rm -fr PAR* >& /dev.null
         mpiexec -n 1 $TARGET < 1b.in >& tmp ;
         grep "Total    = " PAR0001/tmp >> OUT_TEST; rm PAR0001/tmp; tail -2 PAR0001/WRK.ala10 >> OUT_TEST
         rm -fr PAR* >& /dev.null
         echo "Testing 1c.in..." >> OUT_TEST
         mpiexec -n 1 $TARGET < 1c.in >& tmp ;
         grep "Total    = " PAR0001/tmp >> OUT_TEST; rm PAR0001/tmp; tail -2 PAR0001/WRK.ala10 >> OUT_TEST
         rm -fr PAR* >& /dev.null
         echo "Testing 1d.in..." >> OUT_TEST
         mpiexec -n 1 $TARGET < 1d.in >& tmp ;
         grep "Total    = " PAR0001/tmp >> OUT_TEST; rm PAR0001/tmp; tail -4 PAR0001/WRK.ala10 >> OUT_TEST
# Second  test 
# generate state A and B starting equilibrium distributions
# state A phase space points (folded 10ala) in RESTART_A directory
# state B phase space points (unfolded 10ala) in RESTART_B directory
         echo "Doing second  test for SMD ....." 
         echo "Testing 2a.in..." >> OUT_TEST
         mpiexec -n 1 $TARGET < 2Pa.in >& tmpa ;  
         grep "Total    = " tmpa >> OUT_TEST ;
         echo "Testing 2b.in..." >> OUT_TEST ;
         mpirun -n 1 $TARGET < 2Pb.in >& tmpb   ;
         grep "Total    = " tmpb >> OUT_TEST
      fi
   fi 
fi
# Third test 
#  
exit
echo "Doing third and final test for SMD ....." 
# generate  $NPROCS forward work measurements in parallel
mpiexec -n $NPROCS < $TARGET 3a.in
for i in `ls -do PAR*`; do  mv WRKa.1.$i FORWARD; done
rm -fr PAR*
# generate  $NPROCS reverse work measurements in parallel
mpiexec -n $NPROCS < $TARGET 3b.in
for i in `ls -do PAR*`; do  mv WRKb.1.$i REVERSE; done
rm -fr PAR*

for i in ls FORWARD/WRK* ; do grep 'bond' FORWARD/$i | awk '{print  $5,$7}' > FORWARD/$i.N ; done
for i in ls REVERSE/WRK* ; do grep 'bond' REVERSE/$i | awk '{print  $5,$7}' > REVERSE/$i.N ; done
rm FORWARD/WRKa.1.PAR00??
rm REVERSE/WRKa.1.PAR00??

exit
