C each process arrives with: 
C para_index: its order 
C rem_factor: its value of the scaling factor
C rem_pot: its potential

C Four replicas
C Even number of REM steps           C Odd number of REM steps
C ------------------- para_index = 4  C ------------------- para_index = 4
C         | |                        C
C ------------------- para_index = 3  C ------------------- para_index = 3
C                                    C         | |
C ------------------- para_index = 2  C ------------------- para_index = 2
C         | |                        C
C ------------------- para_index = 1  C ------------------- para_index = 1

      if(nstep.gt.nrject) THEN  ! attempts exchanges only after thermalization is over.
        if(mod(time*nstep,rem_ts).lt.1.d-10) then 
          step_rem = step_rem + 1
          low = 999             ! initialize low and high
          high  = 999   
          if(iproc.eq.0) random_number = ranf(0.d0) ! the root process generates a random number random_number
          call MPI_BCAST(random_number,1,MPI_DOUBLE_PRECISION,0 ! MPI_BCAST broadcasts the random number from the root process to all the processes
     &         ,MPI_COMM_WORLD,ierr) 
          
          if(mod(step_rem+para_index,2).eq.0) then ! Find the partner replica and assign the roles in the pair: the low replica will take all the decisions 
            if(para_index.ne.1) then  
              high = iproc
              do i = 0,nproc-1
                if(rem_table(i).eq.(para_index-1)) low = i
              enddo
            endif
          else
            if(para_index.ne.nproc) then
              low = iproc
              do i = 0,nproc-1
                if(rem_table(i).eq.(para_index+1)) high = i
              enddo
            endif
          endif
          
          if(iproc.eq.high) then ! The high replica send its potential to the low replica
            call MPI_SEND(rem_pot,3,MPI_DOUBLE_PRECISION,low,0
     &           ,MPI_COMM_WORLD,ierr)
          elseif(iproc.eq.low) then 
            call MPI_RECV(rem_pot1,3,MPI_DOUBLE_PRECISION,high,0
     &           ,MPI_COMM_WORLD,status,ierr)
          endif

          call MPI_BARRIER(MPI_COMM_WORLD,ierr)            

          if(iproc.eq.low) then 
            rem_delta = 0.d0
            do i = 1,3
              rem_delta = rem_delta + 
     &             (rem_mat(para_index+1,i)-rem_mat(para_index,i)) * 
     &             (rem_pot1(i)-rem_pot(i))
            enddo
            rem_delta = rem_delta / (gascon*t*0.001d0)
            if(rem_delta.ge.0.d0) then ! accept the exchange
              rep_acc(para_index) = rep_acc(para_index) + 1
              para_index1 = para_index
              para_index = para_index + 1
              do i = 1,3
                rem_factor(i) = rem_mat(para_index,i)
              enddo
            else
              rem_boltz = dexp(rem_delta)
              if(random_number.le.rem_boltz) then ! accept the exchange
                rep_acc(para_index) = rep_acc(para_index) + 1
                para_index1 = para_index
                para_index = para_index + 1
                do i = 1,3
                  rem_factor(i) = rem_mat(para_index,i)
                enddo
              else              ! reject the exchange
                para_index1 = para_index + 1 ! the index of the high replica remains the same
              endif
            endif
            call MPI_SEND(para_index1,1,MPI_INTEGER,high,1 ! the low replica sends the new replica index to the high replica
     &           ,MPI_COMM_WORLD,ierr)
          elseif(iproc.eq.high) then 
            call MPI_RECV(para_index1,1,MPI_INTEGER,low,1
     &           ,MPI_COMM_WORLD,status,ierr)
            para_index = para_index1
            do i = 1,3
              rem_factor(i) = rem_mat(para_index,i)
            enddo
          endif
          
          call MPI_BARRIER(MPI_COMM_WORLD,ierr)            
          
C update all the vectors
          call MPI_ALLGATHER(para_index,1,MPI_INTEGER,rem_table,1
     &         ,MPI_INTEGER,MPI_COMM_WORLD,ierr)
          
          if(mod(time*nstep,rem_print).lt.1.d-10.and.nstep.gt.1) then 
            call MPI_REDUCE (rep_acc,rem_acc, nproc,
     &           MPI_INTEGER,MPI_SUM, 0, MPI_COMM_WORLD,
     &           ierr) 
            if(iproc.eq.0) then 
              write(*,*) '                  Exchange number: ', step_rem
              do i = 1,nproc-1
                write(*,'(15x,i5,a7,i5,a9,f8.3)') i, ' < = > ',  i+1,
     &               ' Nacc/N% ', 2.*float(rem_acc(i))*100.
     &               /float(step_rem)
              enddo
            endif
          endif
        endif
      endif
      
